package inf112.skeleton.app;

public class CollisionDetection {

    public void checkCollision(Player player, IGameObject gameobject) {
        // Player sides
        int p_LeftSide = player.x - player.w / 2;
        int p_RightSide = player.x + player.w / 2;
        int p_DownSide = player.y + player.h / 2;
        int p_UpperSide = player.y - player.h / 2;

        // Gameobject sides
        int w_LeftSide = gameobject.getX() - gameobject.getWidth() / 2;
        int w_RightSide = gameobject.getX() + gameobject.getWidth() / 2;
        int w_DownSide = gameobject.getY() + gameobject.getHeight() / 2;
        int w_UpperSide = gameobject.getY() - gameobject.getHeight() / 2;

        boolean leftsideCollide = p_LeftSide - player.getSpeed() < w_RightSide && p_LeftSide > w_LeftSide;
        boolean rightsideCollide = p_RightSide < w_RightSide && p_RightSide + player.getSpeed() > w_LeftSide;
        boolean heightCollide = p_DownSide > w_UpperSide && p_UpperSide < w_DownSide;

        boolean downsideCollide = p_DownSide + player.gravity > w_UpperSide && p_DownSide < w_DownSide;
        boolean upsideCollide = p_UpperSide > w_UpperSide && p_UpperSide - 6 < w_DownSide;
        boolean sidesCollide = p_LeftSide < w_RightSide && p_RightSide > w_LeftSide;

        // CHECK LEFT
        if (leftsideCollide && heightCollide) {
            gameobject.collisionLeft(player);
        }

        // CHECK RIGHT
        if (rightsideCollide && heightCollide) {
            gameobject.collisionRight(player);
        }

        //CHECK DOWN
        if (downsideCollide && sidesCollide) {
            gameobject.collisionDown(player);
        }

        //CHECK UP
        if (upsideCollide && sidesCollide) {
            gameobject.collisionUp(player);
        }
    }

}
