package inf112.skeleton.app;

import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.Image;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;

public class Waffle implements IGameObject {
    int x, y, w, h;
    Image waffleImg =  new Image("file:src/PlayerImage/waffle.png");

    public Waffle(int X, int Y, int W, int H) {
        this.x = X;
        this.y = Y;
        this.w = W;
        this.h = H;
    }

    public int getHeight() {
        return this.h;
    }

    public int getWidth() {
        return this.w;
    }

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }


    public void drawWafflePoints(GraphicsContext gc, double x, double y, int w, int h) {
        gc.drawImage(waffleImg, x - w/2.0, y - h/2.0, w, h);
    }

    public void drawWaffleText(GraphicsContext gc, double w, double h) {
        int width = 400;
        int height = 200;
        double x = w/2 - width/2;
        double y = h/3.5 - height/2;

        gc.setFill(Color.rgb(0, 0, 0, 0.8));
        gc.fillRoundRect(x, y, width, height, 35, 35);

        gc.setFill(Color.WHITE);
        gc.setFont(new Font("Comic sans MS", 20));
        gc.fillText("Hei! Vaffeltorsdag er stengt og på\ngrunn av en feil i systemet er den aller\nsiste vaffelen laget til " +
                "to personer,\ndeg og Anya!!! Kjemp mot Anya for å\nsikre deg den siste vaffelen.", x + 30, y + 50);
        gc.restore();
    }

    public void waffleCount(GraphicsContext gc, Player player) {
        gc.setFill(Color.WHITE);
        gc.setFont(Font.font("Verdana", FontWeight.BOLD, 35));
        gc.fillText("x" + player.waffleScore, 65, 95);
        gc.restore();
    }

    public void collisionLeft (Player player) {
        player.waffleScore++;
        player.collisionWithWaffle = true;
    }

    public void collisionRight (Player player) {
        player.waffleScore++;
        player.collisionWithWaffle = true;
    }

    public void collisionDown (Player player) {
        player.waffleScore++;
        player.collisionWithWaffle = true;
    }

    public void collisionUp (Player player) {
        player.waffleScore++;
        player.collisionWithWaffle = true;
    }

}
