package inf112.skeleton.app;

import javafx.scene.paint.Paint;

public class Wall implements IGameObject{
    int x, y, w, h;
    Paint color;

    public Wall(int X, int Y, int W, int H, Paint color) {
        this.x = X;
        this.y = Y;
        this.w = W;
        this.h = H;
        this.color = color;
    }

    public int getHeight() {
        return this.h;
    }

    public int getWidth() {
        return this.w;
    }

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }

    public Paint getColor() {
        return this.color;
    }


    public void collisionLeft (Player player) {
        player.canMoveLeft = false;
    }

    public void collisionRight (Player player) {
        player.canMoveRight = false;
    }

    public void collisionDown (Player player) {
        player.canMoveDown = false;
        player.onGround = true;
    }

    public void collisionUp (Player player) {
        player.canMoveUp = false;
        player.jump = false;
        player.frames = 0;
    }
}
